import socket

import requests

from reviewllama.configs import OllamaConfig


def is_ollama_available(config: OllamaConfig, timeout: int = 5) -> bool:
    host, port = config.base_url.split(":")
    try:
        with socket.create_connection((host, port), timeout=timeout):
            pass

        # Then check if Ollama API is responding
        response = requests.get(f"http://{host}:{port}/api/tags", timeout=timeout)
        return response.status_code == 200

    except (socket.error, requests.exceptions.RequestException, Exception):
        return False
